//App.c
#include "App.h"
#include "ehcommon.h"
#include "Genre.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
void App_App(App *app, const char *fname);
App *New_App(const char *fname)
{
    App *app = 0;
    app = (App *)malloc(sizeof(App));
    App_App(app, fname);
    return app;
}
void App_Load(App *app);
void App_App(App *app, const char *fname)
{
    //memset(app->fname, 0, sizeof(app->fname));
    strcpy_s(app->fname, FILENAME_MAX, fname);
    app->genres = New_EHArray(0, 0);
    app->last_gnum = 0;
    App_Load(app);
    printf("ƹ Ű .\n");
    getkey();
}
void App_DeSerialize(App *app,FILE *fp);
void App_Load(App *app)
{
    FILE *fp = 0;
    fopen_s(&fp, app->fname, "r");//fp = fopen(app->fname,"r");
    if (fp)
    {
        App_DeSerialize(app, fp);
        fclose(fp);
    }
    else
    {
        printf("ȯմϴ.\n");
    }
}
void App_DeSerialize(App *app, FILE *fp)
{
    int n = 0;
    int i = 0;
    Genre *genre = 0;
    fread(&app->last_gnum, sizeof(int), 1, fp);
    fread(&n, sizeof(int), 1, fp);
    for (i = 0; i < n; i++)
    {
        genre = New_Genre2(fp);
        EHArray_PushBack(app->genres, genre);
    }
}

int App_SelectMenu(App *app);
void App_AddGenre(App *app);
void App_RemoveGenre(App *app);
void App_ListGenre(App *app);
void App_ListBookAtAGenre(App *app);
void App_AddBook(App *app);
void App_FindBookBySeq(App *app);
void App_FindBookByTitle(App *app);
void App_ListAll(App *app);
void App_Run(App *app)
{
    int key = 0;
    while ((key = App_SelectMenu(app)) != ESC)
    {
        switch (key)
        {
        case F1: App_AddGenre(app); break;
        case F2: App_RemoveGenre(app); break;
        case F3: App_ListGenre(app); break;
        case F4: App_ListBookAtAGenre(app); break;
        case F5: App_AddBook(app); break;
        case F6: App_FindBookBySeq(app); break;
        case F7: App_FindBookByTitle(app); break;
        case F8: App_ListAll(app); break;
        default: printf("߸ Ͽϴ.\n");  break;
        }
        printf("ƹ Ű .\n");
        getkey();
    }
}
int App_SelectMenu(App *app)
{
    clrscr();
    printf("帣   α׷\n");
    printf("F1: 帣 ߰ F2: 帣  F3: ü 帣 \n");
    printf("F4: Ư 帣   \n");
    printf("F5:  ߰ F6:  ˻(Ϸùȣ) F7:  ˻()\n");
    printf("F8: ü   ESC: \n");
    return getkey();
}

Iterator App_FindGenre(App *app, const char *gname);
void App_AddGenre(App *app)
{
    char gname[MAX_GNAME_LEN]="";
    Iterator seek = 0;
    Genre *genre = 0;

    printf("%d° ߰ 帣:", app->last_gnum + 1);
    gets_s(gname, MAX_GNAME_LEN);

    seek = App_FindGenre(app, gname);
    if (seek != EHArray_End(app->genres))
    {
        printf("̹ ϴ 帣Դϴ.\n");
        return;
    }

    genre = New_Genre(app->last_gnum + 1, gname);
    app->last_gnum++;
    EHArray_PushBack(app->genres, genre);
}
Iterator App_FindGenre(App *app, const char *gname)
{
    Iterator seek;
    Iterator last;

    Genre *genre = 0;
    const char *sgname = 0;

    seek = EHArray_Begin(app->genres);
    last = EHArray_End(app->genres);

    for (; seek != last; ++seek)
    {
        genre = (Genre *)(*seek);
        sgname = Genre_GetName(genre);
        if (strcmp(gname, sgname) == 0)
        {
            break;
        }
    }
    return seek;
}
void App_RemoveGenre(App *app)
{
    char gname[MAX_GNAME_LEN] = "";
    Iterator seek = 0;
    Genre *genre = 0;    

    App_ListGenre(app);
    printf(" 帣:");
    gets_s(gname, MAX_GNAME_LEN);

    seek = App_FindGenre(app, gname);
    if (seek == EHArray_End(app->genres))
    {
        printf("߸ Ͽϴ.\n");
        return;
    }
    genre = (Genre *)(*seek);
    Delete_Genre(genre);
    EHArray_Erase(app->genres, seek);
}
void App_ListGenre(App *app)
{
    Iterator seek = EHArray_Begin(app->genres);
    Iterator last = EHArray_End(app->genres);
    Genre *genre = 0;
    for (; seek != last; ++seek)
    {
        genre = (Genre *)(*seek);
        Genre_View(genre);
    }
}
void App_ListBookAtAGenre(App *app)
{
    char gname[MAX_GNAME_LEN] = "";
    Iterator seek = 0;
    Genre *genre = 0;
    App_ListGenre(app);
    printf("  Ȯ 帣:");
    gets_s(gname, MAX_GNAME_LEN);
    seek = App_FindGenre(app, gname);
    if (seek == EHArray_End(app->genres))
    {
        printf("߸ Ͽϴ.\n");
        return;
    }
    genre = (Genre *)(*seek);
    Genre_ViewAll(genre);
}
void App_AddBook(App *app)
{
    char gname[MAX_GNAME_LEN] = "";
    char author[MAX_ANAME_LEN] = "";
    char title[MAX_TNAME_LEN] = "";
    Iterator seek;
    Genre *genre = 0;

    App_ListGenre(app);
    printf(" ߰ 帣:");
    gets_s(gname, MAX_GNAME_LEN);
    seek = App_FindGenre(app, gname);
    if (seek == EHArray_End(app->genres))
    {
        printf("߸ Ͽϴ.\n");
        return;
    }

    printf(":");
    gets_s(title, MAX_TNAME_LEN);
    printf("ڸ:");
    gets_s(author, MAX_ANAME_LEN);
    genre = (Genre *)(*seek);
    Genre_AddBook(genre, title, author);
}
void App_FindBookBySeq(App *app)
{
    char gname[MAX_GNAME_LEN] = "";
    Iterator seek = 0;
    Genre *genre = 0;
    int bnum = 0;
    Book *book = 0;

    App_ListGenre(app);
    printf("˻ 帣:");
    gets_s(gname, MAX_GNAME_LEN);

    seek = App_FindGenre(app, gname);
    if (seek == EHArray_End(app->genres))
    {
        printf("߸ Ͽϴ.\n");
        return;
    }
    printf(" ȣ:");
    scanf_s("%d", &bnum);
    genre = (Genre *)(*seek);
    book = Genre_FindBookByNum(genre, bnum);
    if (book)
    {
        Book_View(book);
    }
    else
    {
        printf(" ʴ  ȣԴϴ.\n");
    }
}
void App_FindBookByTitle(App *app)
{
    char gname[MAX_GNAME_LEN] = "";
    Iterator seek = 0;
    Genre *genre = 0;
    char title[MAX_TNAME_LEN] = "";
    Book *book = 0;

    App_ListGenre(app);
    printf("˻ 帣:");
    gets_s(gname, MAX_GNAME_LEN);

    seek = App_FindGenre(app, gname);
    if (seek == EHArray_End(app->genres))
    {
        printf("߸ Ͽϴ.\n");
        return;
    }
    printf(" :");
    gets_s(title, MAX_TNAME_LEN);
    genre = (Genre *)(*seek);
    book = Genre_FindBookByTitle(genre, title);
    if (book)
    {
        Book_View(book);
    }
    else
    {
        printf(" ʴ  ȣԴϴ.\n");
    }
}
void App_ListAll(App *app)
{
    Iterator seek = EHArray_Begin(app->genres);
    Iterator last = EHArray_End(app->genres);
    Genre *genre = 0;
    for (; seek != last; ++seek)
    {
        genre = (Genre *)(*seek);
        Genre_ViewAll(genre);
    }
}
void App_Save(App *app);
void App_TApp(App *app);
void Delete_App(App *app)
{
    App_Save(app);
    App_TApp(app);
    free(app);
}

void App_Serialize(App *app,FILE * fp);
void App_Save(App *app)
{
    FILE *fp = 0;
    fopen_s(&fp, app->fname, "w"); // fp = fopen(app->fname, "w");
    if (fp)
    {
        App_Serialize(app, fp);
        fclose(fp);
    }
    else
    {
        printf("  \n");
    }
}
void App_Serialize(App *app, FILE * fp)
{
    Iterator seek;
    Iterator last;
    int n = 0;
    Genre *genre = 0;

    fwrite(&app->last_gnum, sizeof(int), 1, fp);
    n = EHArray_GetSize(app->genres);
    fwrite(&n, sizeof(int), 1, fp);

    seek = EHArray_Begin(app->genres);
    last = EHArray_End(app->genres);

    for (; seek != last; ++seek)
    {
        genre = (Genre *)(*seek);
        Genre_Serialize(genre, fp);
    }

}
void App_TApp(App *app)
{
    Iterator seek = 0;
    Iterator last=0;
    Genre *genre = 0;
    seek = EHArray_Begin(app->genres);
    last = EHArray_Begin(app->genres);

    for (; seek != last; ++seek)    
    {
        genre = (Genre *)(*seek);
        Delete_Genre(genre);        
    }
    Delete_EHArray(app->genres);
}