//Genre.c
#include "Genre.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

void Genre_Genre(Genre *genre, int gnum, const char *gname);
Genre *New_Genre(int gnum, const char *gname)
{
    Genre *genre = 0;
    genre = (Genre *)malloc(sizeof(Genre));
    Genre_Genre(genre, gnum, gname);
    return genre;
}
void Genre_Genre(Genre *genre, int gnum, const char *gname)
{
    genre->gnum = gnum;
    strcpy_s(genre->name, MAX_GNAME_LEN, gname);
    genre->books = New_EHArray(0, 0);
    genre->last_bnum = 0;
}
void Genre_TGenre(Genre *genre);
void Delete_Genre(Genre *genre)
{
    Genre_TGenre(genre);
    free(genre);
}
void Genre_TGenre(Genre *genre)
{
    Book *book = 0;
    Iterator seek;
    Iterator last;
    seek = EHArray_Begin(genre->books);
    last = EHArray_End(genre->books);
    for (; seek != last; ++seek)
    {
        book = (Book *)(*seek);
        Delete_Book(book);
    }
    Delete_EHArray(genre->books);
}
const char *Genre_GetName(Genre *genre)
{
    return genre->name;
}
void Genre_View(Genre *genre)
{
    printf("帣 ȣ:%d 帣 ̸:%s\n", genre->gnum, genre->name);
}
Book *Genre_AddBook(Genre *genre, const char *title, const char *author)
{
    Book *book = 0;
    genre->last_bnum++;
    book = New_Book(genre->last_bnum, title, author);
    EHArray_PushBack(genre->books, book);
    printf(" ȣ:%d  ߰Ͽϴ.\n", genre->last_bnum);
    return book;
}
void Genre_ViewAll(Genre *genre)
{
    Iterator seek = EHArray_Begin(genre->books);
    Iterator last = EHArray_End(genre->books);
    Book *book = 0;
    Genre_View(genre);
    for (; seek != last; ++seek)
    {
        book = (Book *)(*seek);
        Book_View(book);
    }
}
Book *Genre_FindBookByNum(Genre *genre, int bnum)
{
    Iterator seek;
    Iterator last;
    Book *book = 0;

    seek = EHArray_Begin(genre->books);
    last = EHArray_End(genre->books);

    Genre_View(genre);
    for (; seek != last; ++seek)
    {
        book = (Book *)(*seek);
        if (Book_GetNum(book) == bnum)
        {
            return book;
        }
    }
    return 0;
}
Book *Genre_FindBookByTitle(Genre *genre, const char *title)
{
    Iterator seek;
    Iterator last;
    Book *book = 0;
    const char *stitle = 0;

    seek = EHArray_Begin(genre->books);
    last = EHArray_End(genre->books);

    Genre_View(genre);
    for (; seek != last; ++seek)
    {
        book = (Book *)(*seek);
        stitle = Book_GetTitle(book);
        if (strcmp(title,stitle)==0)
        {
            return book;
        }
    }
    return 0;
}
void Genre_Serialize(Genre *genre, FILE *fp)
{
    Iterator seek;
    Iterator last;
    Book *book = 0;
    int n = 0;

    fwrite(genre->name, sizeof(genre->name), 1, fp);
    fwrite(&(genre->gnum), sizeof(int), 1, fp);
    fwrite(&(genre->last_bnum), sizeof(int), 1, fp);

    n = EHArray_GetSize(genre->books);
    fwrite(&n, sizeof(int), 1, fp);
    seek = EHArray_Begin(genre->books);
    last = EHArray_End(genre->books);
    for (; seek != last; ++seek)
    {
        book = (Book *)(*seek);
        Book_Serialize(book, fp);
    }
}
void Genre_DeSerialize(Genre *genre,FILE * fp);
Genre *New_Genre2(FILE *fp)
{
    Genre *genre = 0;
    genre = New_Genre(0, "");
    Genre_DeSerialize(genre, fp);
    return genre;
}
void Genre_DeSerialize(Genre *genre, FILE * fp)
{
    Book *book = 0;
    int i = 0;
    int n = 0;
    fread(genre->name, sizeof(genre->name), 1, fp);
    fread(&genre->gnum, sizeof(int), 1, fp);
    fread(&genre->last_bnum, sizeof(int), 1, fp);
    fread(&n, sizeof(int), 1, fp);

    for (i = 0; i < n; i++)
    {
        book = New_Book2(fp);
        EHArray_PushBack(genre->books, book);
    }
}